//**-------------------------- INPUT -----------------------
//** SCICOS "Hardware In the Loop"
//** Input Scicos HIL block for Comedi Devices 
//**
//** 16 Feb 2010: for ScicosLab 4.4. What else ?
//**
//** Copyright roberto.bucher@supsi.ch
//**           simone.mannori@gmail.com
//**
function [x,y,typ] = comedi_an_in(job,arg1,arg2)

x=[]; y=[]; typ=[];

select job //** main state machine switch

case "plot" then                   //** plot the block 
  graphics = arg1.graphics;
  exprs = graphics.exprs;
  ch   = exprs(1)(1);
  name = exprs(1)(2);
  standard_draw(arg1)

case "getinputs" then
  [x,y,typ]=standard_inputs(arg1) //** inputs 

case "getoutputs" then
  [x,y,typ]=standard_outputs(arg1) //** outputs 

case "getorigin" then
  [x,y]=standard_origin(arg1)      //** location 

case "set" then
  x = arg1; 
  model = arg1.model;
  graphics = arg1.graphics;
  label = graphics.exprs;
  
  //** open a dialog box to SET the model pameters 
  while %t do
    [ok, ch, name, com_range, aref, lab]= getvalue('Set Comedi A/D block parameters',..
                                          [ 'Channel' ;
                                            'Device'  ;
	                                    'Range'   ;
                                            'Aref'    ],..
                                                        list('vec',1,'str',1,'vec',1,'vec',1'), label(1) )
                                             //** Channel->ch  Device->name  Range->com_range  Aref->aref        
    
    if ~ok then break,end //** if the input fail then exit 

    label = list( [sci2exp(ch), name, sci2exp(com_range), sci2exp(aref)], [] );
        
    funam = "comedi_analog_input";
    funtyp = 4; //** valid numbers are 4->(C) 5->(Scilab) 

    depu=%t; dept=%f;
    dep_ut=[depu dept];
    
    o=1; i=[]; ci=1; co=[];
    [model,graphics,ok] = check_io(model,graphics,i,o,ci,co);
   
    if ok then
      model.sim = list(funam, funtyp); //** simulating function 
      model.in = [] ; //** no input 
      model.out = 1 ; //** one output 
      model.evtin = 1 ; //** event input 
      model.evtout=[]  ; //** no event output 
      model.state=[]   ; //** no state 
      model.dstate=0   ; //** no discrete state 
      model.rpar=[]    ; //** no real parameter 
      
      //** integer parameter
      model.ipar = [ch; com_range; aref; length(name); ascii(name)']

      model.firing=[]       ; //** 
      model.dep_ut = dep_ut ; //** 
      model.nzcross = 0     ;
      x.model = model       ;
      graphics.exprs = label ;
      x.graphics = graphics  ;
      break ; //** Ok, then exit from the while loop :) 
    end
    
  end //** of the while 
  
case "define" then

  ch = 0; //** default settings 
  com_range = 0;
  aref = 0; 
  name = "comedi0"; 

  //** computational function 
  model = scicos_model();
  funam = "comedi_analog_input";
  funtyp = 4; 
  model.sim = list(funam, funtyp) //** simulating function
  
  model.in  = []; //** no input 
  model.out = 1 ; //** one output 
  
  model.evtin  =  1 ; //** one event input  
  model.evtout = [] ; //** no event output 
  
  model.state  = [] ;
  model.dstate = [] ;
  model.rpar   = [] ;
  
  model.ipar = [ch; com_range; aref; length(name); ascii(name)']; 
  
  model.blocktype="d"
  
  model.firing = []
  model.dep_ut = [%t %f]
  model.nzcross=0

  label = list( [sci2exp(ch), name, sci2exp(com_range), sci2exp(aref)], [] );

  gr_i = ['xstringb(orig(1),orig(2),[''Comedi A/D'';name+'' CH-''+string(ch)],sz(1),sz(2),''fill'');'];
  
  x = standard_define([3 2], model, label, gr_i);

end

endfunction
