//**--------------------------------------- OUTPUT -----------------------
//** SCICOS "Hardware In the Loop"
//** Input Scicos HIL block for Comedi Devices 
//**
//** 16 Feb 2010: for ScicosLab 4.4. What else ?
//**
//** Copyright roberto.bucher@supsi.ch
//**           simone.mannori@gmail.com
//**

function [x,y,typ] = comedi_an_out(job,arg1,arg2)

x=[]; y=[]; typ=[];

select job //** main state machine switch

case "plot" then  //** plot the object 
  graphics = arg1.graphics;
  exprs = graphics.exprs;
  ch   = exprs(1)(1);
  name = exprs(1)(2);
  standard_draw(arg1);

case "getinputs" then //** inputs 
  [x,y,typ]=standard_inputs(arg1) //** 

case "getoutputs" then //** 
  [x,y,typ]=standard_outputs(arg1)

case "getorigin" then  //** 
  [x,y]=standard_origin(arg1)

case "set" then //** set parameters 
  x = arg1 ; //** 
  model = arg1.model; 
  graphics = arg1.graphics;
  label = graphics.exprs;
  
  while %t do
       [ok,ch,name,com_range,aref,lab] = getvalue('Set Comedi block parameters',..
                                         [ 'Channel';
                                           'Device';
	                                   'Range';
                                           'Aref'],..
                                           list('vec',1,'str',1,'vec',1,'vec',1'),label(1))

    if ~ok then break,end
    
    label = list( [sci2exp(ch), name, sci2exp(com_range), sci2exp(aref)], [] );
    
    funam  = "comedi_analog_output";
    funtyp = 4 ;
    
    depu=%t; dept=%f;
    dep_ut=[depu dept];
    
    o=[]; i=1; ci=1; co=[];
    
    [model,graphics,ok] = check_io(model,graphics,i,o,ci,co)
    
    if ok then
      model.sim = list(funam,funtyp) ; //** computational function 
      model.in = i ;
      model.out = [] ;
      model.evtin = ci ;
      model.evtout = [] ;
      model.state = [] ;
      model.dstate = 0 ;
      model.rpar = [] ;
     
      //** integer parameter
      model.ipar = [ch; com_range; aref; length(name); ascii(name)']
      
      model.firing = [] ;
      model.dep_ut = dep_ut ;
      model.nzcross = 0 ;
      x.model = model ;
      graphics.exprs = label ;
      x.graphics = graphics ;
      break
    end //** -> exit point 
  
  end //** end of while(1) 

case "define" then      //** the standard define  
  ch = 0; 
  com_range = 0; // default values 
  aref = 0; 
  name = "comedi0";

  model = scicos_model();
  funam = "comedi_analog_output";
  funtyp = 4 ;
  model.sim = list(funam, funtyp) //** simulating function

  model.in = 1 ;
  model.out = [] ;
  model.evtin = 1 ;
  model.evtout = [] ;
  model.state = [] ;
  model.dstate = [] ;
  model.rpar = [] ;

  model.ipar = [ch; com_range; aref; length(name); ascii(name)']; 

  model.blocktype = "d";
  model.firing = [] ;
  model.dep_ut = [%t %f]
  model.nzcross = 0;

  label = list( [sci2exp(ch),name,sci2exp(com_range),sci2exp(aref)], [] ) ; 

  gr_i = ['xstringb(orig(1),orig(2),[''Comedi D/A'';name+'' CH-''+string(ch)],sz(1),sz(2),''fill'');']

  x = standard_define([3 2],model,label,gr_i)

end

endfunction


